Package: CHBUtils
Title: "Useful utility functions used at the core"
Description: "Useful utility functions used at the core"
Version: 0.1
Authors@R: c(person("Rory", "Kirchner", email="rory.kirchner@gmail.com",
    role = c("aut", "cre", "ths")),
    person("John", "Hutchinson", email="jnhutchinson@gmail.com",
    role = c("aut")),
    person("Oliver", "Hofmann", email="ohofmann@hsph.harvard.edu",
    role = c("aut")),
    person("Brad", "Chapman", email="chapmanb@50mail.com",
    role = c("aut")),
    person("Meeta", "Mistry", email="meeta.mistry@gmail.com",
    role = c("aut")),
    person("Lorena", "Pantano", email="lorena.pantano@gmail.com",
    role = c("aut")))
Depends:
    R (>= 3.0.0)
License: "MIT"
LazyData: true
RoxygenNote: 5.0.1

CHBUtils
=========
[![Build Status](https://api.travis-ci.org/hbc/CHBUtils.png)](http://travis-ci.org/hbc/CHBUtils)

Utility functions in R

# Install
```
install.packages("devtools")
library(devtools)
install_git("git://github.com/hbc/CHBUtils.git")
```

qval_asymm <- function(ts, ps){
  require(qvalue)
  m <- length(ps)  ##total number of genes
  m1 <- length(ps[ts <= 0]) ##number of genes with negative test statistic
  m2 <- length(ps[ts > 0])  ##number of genes with positive test statistic
  p1 <- ps[ts <= 0]  ##p-values for genes with negative test statistics
  p2 <- ps[ts > 0]  ##p-values for genes with positive test statistics

  p0 <- qvalue(ps)$pi0  ##estimate of pi0, proportion of genes that are EE
  m0 <- p0*m  ##estimate of number of EE genes
  m0half <- m0/2 ##estimate of number of EE with negative (positive) signs
   
  rkp1 <- rank(p1)
  rkp2 <- rank(p2)

  fdrh1 <- p1*m0half/rkp1
  fdrh2 <- p2*m0half/rkp2

  qv1 <- sapply(rkp1, function(x) min(fdrh1[rkp1>=x]))
  qv2 <- sapply(rkp2, function(x) min(fdrh2[rkp2>=x]))

  qvasymm <- rep(NA, m)
  qvasymm[ts <= 0] <- qv1
  qvasymm[ts > 0] <- qv2

  qvasymm
}

#' Pairwise Principal Component Analysis Plots
#'
#' @param eset ExpressionSet, required
#' @param categories character vector column identifier containing different categories to highlight with colors, required
#' @param secondary_categories character vector column identifier containing different categories to highlight by shape, optional
#' @param title title for the plot, required
#' @param colorpalette vector of RGB colors (long enough for a color per category), required
#' @param alpha alpha shading from 0 (transparent) to 1 (opaque), defaults to 1
#' @param numcomponents number of principal components to plot, defaults to 4 
#' @return pairwise plots of samples plotted by principal component
#' @seealso \code{\link{pair}} which this function uses to plot all pairwise combos
#' @export
#' @examples
#' PCAplot.eset(eset=AffyNorm, categories="groups", title="PCAplot - groups", colorpalette=c("#FF0000", "#00FF00", "#0000FF", alpha=0.8, numcomponents=4)
  

PCAplot.eset <- function(eset=NULL, categories=NULL, secondary_categories=NULL, title=NULL, colorpalette=NULL, alpha=1, numcomponents=4){
    if (missing(eset)){
    stop("Function requires an ExpressionSet")
  }
  pd <- pData(eset)
  if(missing(categories)){
    stop("Function requires you to specify phenoData column name (as categories to highlight)")
  }
  if(missing(title)){
    stop("Function requires you to specify a title for plot")
  }
  if (missing(colorpalette)){
    stop("Funciton requires you to specify a colorpalette")
  }
  if (missing(secondary_categories)){
    shapes=21
  } else {
    shapes <- c(21:25)[factor(as.character(unlist(pd[,secondary_categories])))]
  }
  alpha <- sprintf("%x", ceiling(alpha*255))
  colorpalette <- paste(colorpalette, alpha, sep="")
  eset.core <- exprs(eset) 
  myPca.core <- prcomp(t(eset.core))
  tmpPCAData.core <- as.data.frame(myPca.core$x[,1:numcomponents])
  
  colors <- colorpalette[factor(as.character(unlist(pd[,categories])))]
  if(missing(secondary_categories)){
    legend_values <- unique(cbind(colors, as.character(pd[,categories])))
  } else {
    legend_values <- unique(do.call(cbind, list(shapes, colors, as.character(pd[,categories]), as.character(pd[,secondary_categories]))))
  }
  
  legend_values=unique(cbind(colors, as.character(pd[,categories])))
  pairs(tmpPCAData.core, bg=colors, col="#606060", cex=2, pch=21, main=title, oma=c(8,5,5,14))
  legend("right", cex=0.7, col="#606060", pt.bg=legend_values[,1], pt.cex=1.5, legend=legend_values[,2],  pch=21, bty="n", x.intersp=1)
}

#' ggplot based dendrogram plot 
#'
#' @param x ExpressionSet, required
#' @param title, character vector with title of the plot, optional
#' @param labels.colname character vector of length one with column id of categorical labels, required
#' @param colors.colname character vector of length one with column id of categorical colors, required
#' @return dendrogram plot with categorical labels and colors
#' @seealso \code{\link{ggdendro}} which this function modifies
#' @export
#' @examples
#' plot_dendro <- function(eset, title="mydendrogram", labels.colname="age", colors.colname="genotype")

plot_dendro <- function(x, title="", labels.colname=NULL, colors.colname=NULL) {
  require(ggdendro)
  meta.x <- pData(x)
  # force the metadata into character format so you don't end up with gradient/continuous color schemes for numerical variables in the final plot  
  meta.x <- as.matrix(meta.x) 
  ## do the actual statistics and put into dendrogram 
  myDist <- dist(t(exprs(x)))
  myTree <-hclust(myDist)
  dhc <- as.dendrogram(myTree)
  ddata <- dendro_data(dhc, type="rectangle")
  # the labels of the dendrogram are pulled from the Expression set exprs column names, it's nice to rename them to something more intelligible if you haven't already, as well as match them up to the metadata for label coloring
  ## check to see if the column names of the expression set match anything in the metadata, or match the rownames
  if (identical(colnames(exprs(x)), row.names(meta.x))) {
    meta.x <- row2colnames(meta.x, "rownames")
    matchcol <- "rownames"
  } else if (any(apply(meta.x, 2, function(column) identical(as.character(unlist(column)), colnames(exprs(x)))))) {
    matchcol <- names(which(apply(meta.x, 2, function(column) identical(as.character(unlist(column)), colnames(exprs(x))))))
  } else {
    print("ExpressionSet sampleNames and pData row.names or pData column must match")
    stop()
  }
  ## merge the metadata with the dendrogram labels using the commmon column/rownames you just identified above
  ddata$labels <- merge(ddata$labels, meta.x, by.x="label", by.y=matchcol)
  # plot it like you mean it
  ggplot(segment(ddata)) +
    geom_segment(aes(x=x, y=y, xend=xend, yend=yend)) +
    theme_dendro() +
    geom_text(data=label(ddata), aes_string(x='x', y='y', label=labels.colname, color=colors.colname, hjust=-0.1), size=6)+
    scale_color_brewer(type = "seq", palette = "Set1")+
    coord_flip() + scale_y_reverse(expand=c(0.2, 50)) +
    theme(axis.text.x=element_blank(),
          axis.text.y=element_blank(),
          axis.title.x=element_blank(),
          axis.title.y=element_blank()) +
    ggtitle(title)
}

#' Create report of QC
#'
#' @param path  absolute path to bcbio results (in yaml file after -upload)
#' @param samples  vector indicating the name as samples are in the previous folder
#' @param out path  where you want to create the index.html
#' @param title  this value would be the title of the document
#' @param condition  a vector indicating the groups of the samples
#' @export
#' @examples
#' \dontrun{
#' p<-"absolute paht to bcbio results in yaml file: -upload
#' s<-c("name1","name2","name3","name4")
#' o<-"/path/where/html/will/be/created"
#' t<-"some title for the report"
#' con<-c("TREAT","TREAT","CON","CON")
#' r<-create_report(p,s,o,t,con)
#' }
create_report<-function(path,samples,out,title,condition){
  require(Nozzle.R1)
  report<-""
  report <- newCustomReport( title );
  
  #report <- addTo( report, addTo( newSection( "My Introduction" ),
  #   newParagraph( "Hello World! This is a paragraph of text!" ) ) );
  #report <- addTo( report, addTo( newSection( "My Methods" ),
  #    method ) );
  FRfqc<- i_create_fastqc_figure(path,samples,out)
  Trqc<- i_create_mapping_stats(path,samples,out)
  FRfrccov<- i_create_gene_coverage(path,samples,out)
  Tcounts<- i_create_count_top(path,samples,out)
  FRcounts <- i_create_distribution_counts(path,samples,out,condition)
  
  
  report <- addTo( 
    report, addTo( newSection( "Quality of samples", class="results" ),
                   addTo( newSubSection( "Quality of base calling" ), FRfqc),
                   addTo( newSubSection( "Mapping stats" ), Trqc),
                   addTo( newSubSection("Gene coverage"), FRfrccov),    
                   addTo( newSubSection( "Top expressed genes" ), Tcounts),
                   addTo( newSubSection( "Counts distribution" ), FRcounts[[1]]),
                   addTo( newSubSection( "Normalized counts distribution" ), FRcounts[[2]]),
                   addTo( newSubSection("Cumulative expression"), FRcounts[[3]]),
                   addTo( newSubSection( "Samples similarity" ), FRcounts[[4]])
    )
    
    
  );
  
  return(report)
  
}

#' Write report of QC
#'
#' @param report  an object comming from create_report()
#' @param out  path where you want to create the index.html (same as used in create_report)
#' @export
#' @examples
#' \dontrun{
#' p<-"absolute path to bcbio results in yaml file: -upload
#' s<-c("name1","name2","name3","name4")
#' o<-"/path/where/html/will/be/created"
#' t<-"some title for the report"
#' con<-c("TREAT","TREAT","CON","CON")
#' r<-write_report(p,s,o,t,con)
#' }
write_report<-function(report,outfile){
  writeReport( report, filename=paste(outfile,"/QC.html",sep=""));
  
}


add_DE<-function(report,defile,condition){
  report <- addTo( 
    report,
    addTo(newSection("DE",class="results"),
          addTo(newSubSection("DE genes"),Tedger),
          addTo(newSubSection("Quality of DE analysis"),FRpval)
    )
  )
  
  return(report)
}

#' Plots the differntially expressed genes on an MA plot, ggplot style
#' If adjusted pvalues are present, colors those that pass cutoff red
#' @param pvaldf dataframe, required
#' @param basemean_colid character string, column header of column containing baseMean values, required
#' @param log2foldchange_colid character string, column header of column containing log2 transformed fold change values, required
#' @param adj_pval_colid character string,column header of column containing adjusted pvalues, required
#' @param adj_pval_cutoff, optional, defaults to 0.05
#' @param plottitle character string, title for the plot, optional, defaults to "MA plot"
#' @export
#' @examples
#' plotDE(df, basemean_colid="baseMean",log2foldchange_colid=log2FoldChange, adj_pval_colid="padj", adj_pval_cutoff=0.05, plottitle="My MA plot")

plotDE = function(pvaldf,  basemean_colid=NULL, log2foldchange_colid=NULL, adj_pval_colid=NULL, adj_pval_cutoff=0.05, plottitle="MA plot")  {
  pvaldf$colors <- ifelse(pvaldf[,adj_pval_colid] < adj_pval_cutoff, "sig", "nonsig")
  pvaldf$bm <- pvaldf[,basemean_colid]
  pvaldf$lfc <- pvaldf[,log2foldchange_colid]
  plot <- ggplot(data = pvaldf, aes(x = log(bm), y = lfc, colour = colors)) + 
    geom_point(size = 3)  + 
    scale_colour_manual(name = "BFH adjusted pvalue", values = c("#00000033", "#FF0000FF"), labels = c(paste("q>", adj_pval_cutoff, sep = ""), paste("q<", adj_pval_cutoff, sep = ""))) + 
    labs(title = plottitle)
  plot
}

# copied wholesale from https://github.com/chr1swallace/random-functions
 
## colours, generated by
## library(RColorBrewer)
## rev(brewer.pal(11,name="RdYlBu"))

 
mydplot <- function(ddata, row=!col, col=!row, labels=col) {
  require(ggplot2)
  ## plot a dendrogram
  yrange <- range(ddata$segments$y)
  yd <- yrange[2] - yrange[1]
  nc <- max(nchar(as.character(ddata$labels$label)))
  tangle <- if(row) { 0 } else { 90 }
  tshow <- col
  p <- ggplot() +
        geom_segment(data=segment(ddata), aes(x=x, y=y, xend=xend, yend=yend)) +
        labs(x = NULL, y = NULL) + theme_dendro()
  if(row) {
    p <- p +
      scale_x_continuous(expand=c(0.5/length(ddata$labels$x),0)) +
      theme(axis.text.y = element_text(hjust=1)) +
        coord_flip()
  } else {
    p <- p +
      theme(axis.text.x = element_text(angle = 90, hjust = 1))
  }
return(p)
}
 
g_legend<-function(a.gplot){
## from
## http://stackoverflow.com/questions/11883844/inserting-a-table-under-the-legend-in-a-ggplot2-histogram
  tmp <- ggplot_gtable(ggplot_build(a.gplot))
  leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
  legend <- tmp$grobs[[leg]]
  return(legend)
}

##' Display a ggheatmap
##'
##' this function sets up some viewports, and tries to plot the dendrograms to line up with the heatmap
##' @param L a list with 3 named plots: col, row, centre, generated by ggheatmap
##' @param col.width,row.width number between 0 and 1, fraction of the device devoted to the column or row-wise dendrogram. If 0, don't print the dendrogram
##' @return no return value, side effect of displaying plot in current device
##' @export
##' @author Chris Wallace
ggheatmap.show <- function(L, col.width=0.2, row.width=0.2) {
  require(grid)
  require(ggplot2)
grid.newpage()
top.layout <- grid.layout(nrow = 2, ncol = 2,
widths = unit(c(1-row.width,row.width), "null"),
heights = unit(c(col.width,1-row.width), "null"))
pushViewport(viewport(layout=top.layout))
if(col.width>0)
print(L$col, vp=viewport(layout.pos.col=1, layout.pos.row=1))
if(row.width>0)
print(L$row, vp=viewport(layout.pos.col=2, layout.pos.row=2))
## print centre without legend
print(L$centre +
theme(axis.line=element_blank(),
axis.text.x=element_blank(),axis.text.y=element_blank(),
axis.ticks=element_blank(),
axis.title.x=element_blank(),axis.title.y=element_blank(),
legend.position="none",
panel.background=element_blank(),
panel.border=element_blank(),panel.grid.major=element_blank(),
panel.grid.minor=element_blank(),plot.background=element_blank()),
vp=viewport(layout.pos.col=1, layout.pos.row=2))
## add legend
legend <- g_legend(L$centre)
pushViewport(viewport(layout.pos.col=2, layout.pos.row=1))
grid.draw(legend)
upViewport(0)
}

##' generate a heatmap + dendrograms, ggplot2 style
##'
##' @param x data matrix
##' @param hm.colours vector of colours (optional)
##' @return invisibly returns a list of ggplot2 objects. Display them with ggheatmap.show()
##' @author Chris Wallace
##' @export
##' @examples
##' ## test run
##' ## simulate data
##' library(mvtnorm)
##' sigma=matrix(0,10,10)
##' sigma[1:4,1:4] <- 0.6
##' sigma[6:10,6:10] <- 0.8
##' diag(sigma) <- 1
##' X <- rmvnorm(n=100,mean=rep(0,10),sigma=sigma)
##'  
##' ## make plot
##' p <- ggheatmap(X)
##'  
##' ## display plot
##' ggheatmap.show(p)
ggheatmap <- function(x,
                      hm.colours= c("#ffffcc", "#ffeda0", "#fed976",
                        "#feb24c", "#fd8d3c", "#fc4e2a", "#e31a1c",
                        "#bd0026", "#800026")) {
  require(ggdendro)
  require(ggplot2)
  require(reshape)
  require(grid)
  #my.colours = rev(c("#ffffcc", "#ffeda0", "#fed976", "#feb24c", "#fd8d3c",
  #  "#fc4e2a", "#e31a1c", "#bd0026", "#800026"))
  if(is.null(colnames(x)))
    colnames(x) <- sprintf("col%s",1:ncol(x))
  if(is.null(rownames(x)))
    rownames(x) <- sprintf("row%s",1:nrow(x))
  ## plot a heatmap
  ## x is an expression matrix
  row.hc <- try(hclust(dist(x), "ward.D"),silent=T)
  if (class(row.hc)=="try-error"){
    row.hc <- try(hclust(dist(x), "ward"),silent=T)
  }
  col.hc <- try(hclust(dist(t(x)), "ward.D"),silent=T)
  if (class(col.hc)=="try-error"){
    col.hc <- try(hclust(dist(t(x)), "ward"),silent=T)
  }
  
  row.dendro <- dendro_data(as.dendrogram(row.hc),type="rectangle")
  col.dendro <- dendro_data(as.dendrogram(col.hc),type="rectangle")
 
  ## dendro plots
  col.plot <- mydplot(col.dendro, col=TRUE, labels=TRUE) +
        scale_x_continuous(breaks = 1:ncol(x),labels=col.hc$labels[col.hc$order]) +
        theme(plot.margin = unit(c(0,0,0,0), "lines"))
  row.plot <- mydplot(row.dendro, row=TRUE, labels=TRUE) +
        scale_x_continuous(breaks = 1:nrow(x),labels=row.hc$labels[row.hc$order]) +
        theme(plot.margin = unit(c(0,0,0,0), "lines"))
 
  ## order of the dendros
  col.ord <- match(col.dendro$labels$label, colnames(x))
  row.ord <- match(row.dendro$labels$label, rownames(x))
  xx <- x[row.ord,col.ord]
  dimnames(xx) <- NULL
  xx <- melt(xx)
 
  centre.plot <- ggplot(xx, aes(X2,X1)) + geom_tile(aes(fill=value), colour="white") +
        scale_fill_gradientn(colours = hm.colours) +
        labs(x = NULL, y = NULL) +
        scale_x_continuous(expand=c(0,0)) +
        scale_y_continuous(expand=c(0,0),breaks = NULL) +
        theme(plot.margin = unit(rep(0, 4), "lines"))
  ret <- list(col=col.plot,row=row.plot,centre=centre.plot)
  invisible(ret)
}
 

qqplot2 <- function(x, y) {
    # lifted from http://stats.stackexchange.com/questions/12392/how-to-compare-two-datasets-with-q-q-plot-using-ggplot2
    sx <- sort(x)
    sy <- sort(y)
    lenx = length(sx)
    leny = length(sy)
    if (leny < lenx) {
        sx = approx(1L:lenx, sx, n = leny)$y
    }
    if (leny > lenx) {
        sy = approx(1L:leny, sy, n = lenx)$y
    }
    df = data.frame(sx=sx, sy=sy)
    require(ggplot2)
    g = ggplot(df) + geom_point(aes(x=sx, y=sy))
    return(g)
}

# reduce clusterprofile output
reduce_cp = function(genes, lim=100){
    seen = c()
    idx = sapply(genes, function(x){
        if (x == "")
            return(FALSE)
        here = as.character(as.vector(unlist(strsplit(x, split = "/"))))
        if (length(here) > lim)
            return(FALSE)
        c = intersect(seen, here)
        seen <<- unique(c(seen, here))
        score = 0.9 * length(here)
        if (length(c) < score)
            return(TRUE)
        return(FALSE)
    })
    idx
}

.isvalid= function(dd){
    if (is.null(dim(dd))){
        return(FALSE)
    }
    if (nrow(dd)==0){
        return(FALSE)
    }
    return(TRUE)
}

#' Clean and print results from enrichGO
#'
#' @param ego result object from enrichGO
#' @param limit integer limiting the number
#' of genes in each category. Bigger names
#' will give broad categories.
print_enrichGO = function(ego, limit = 100){
    
    require(knitr)
    if (.isvalid(ego)){
        idx = reduce_cp(ego$geneID, limit)
        return(kable(ego[idx, 1:7]))
    }
}

#' Run GO using clusterprofiler
#' 
#' @param genes character vector with list of genes
#' @param org OrgDb object (org.Mm.eg.db)
#' @param from character indicanting the name gene type.
#' Options at: (keytypes(org.Mm.eg.db))
#' @param ont ontology to do, BP, MF, CC
#' @param universe character vector with list of genes to use as universe
runGO = function(genes, org, from="SYMBOL", ont="BP", universe=NULL){
    require(clusterProfiler)
    require(AnnotationDbi)
    require(Rgraphviz)
   
    stopifnot(class(genes)=="character")
    .accnum = convertIDs(genes, from, "ENTREZID", org, "useFirst")
    .accnumUNI = convertIDs(universe, from, "ENTREZID", org, "useFirst")
    if(!is.null(universe)){
        stopifnot(class(universe)=="character")
        stopifnot(length(universe)>length(genes))
        stopifnot(sum(!is.na(.accnum))>0)
        stopifnot(sum(!is.na(.accnumUNI))>0)
    }
    ego <- enrichGO(gene = .accnum[!is.na(.accnum)], universe = .accnumUNI,
                    OrgDb = org, ont = ont, pAdjustMethod = "BH",
                    pvalueCutoff = 0.01, qvalueCutoff = 0.05, readable = TRUE)
    if("result" %in% slotNames(ego)){
        ego = simplify(ego)
        return(list(table=print_enrichGO(ego@result),
                    plot=dotplot(ego),
                    obj=ego))
        # plotGOgraph(ego)
    }
    
}

# adapted from http://stackoverflow.com/questions/4090169/elegant-way-to-check-for-missing-packages-and-install-them
is_package_installed = function(package) {
    available = suppressMessages(suppressWarnings(sapply(package, require,
        quietly = TRUE, character.only = TRUE, warn.conflicts = FALSE)))
    missing = package[!available]
    if (length(missing) > 0) return(FALSE)
    return(TRUE)
}

install.cran = function(packages, default_mirror="http://cran.at.r-project.org") {
    for(i in packages) {
        if(!is_package_installed(i)) {
            options(repos = c(CRAN = defaultCRANmirror))
            suppressMessage(suppressWarnings(install.packages(i, dependencies = TRUE, default_mirror)))
        }
    }
}

install.bioconductor = function(packages) {
  source("http://bioconductor.org/biocLite.R")
  for(i in packages) {
    #  require returns TRUE invisibly if it was able to load package
    if(!is_package_installed(i)) {
      options(repos = c(CRAN = defaultCRANmirror))
      suppressMessage(suppressWarnings(biocLite(i, ask=FALSE)))
    }
  }
}

install.github = function(packages, username) {
    install.cran(c("devtools"))
    for(i in packages) {
        if(!is_package_installed(i)) {
            options(repos = c(CRAN = defaultCRANmirror))
            suppressMessage(suppressWarnings(biocLite(i, ask=FALSE)))
        }
    }
}

#' Annotate Dataframe containing Ensembl IDs with Gene Symbols and Descriptions
#'
#' @param df dataframe, required
#' @param df_ensemblid_header, character string containing the name of the dataframe column with ensembl ids, required
#' @param biomart_ensembl_dataset, character string describing the biomart dataset to use, required
#' @param biomart_ensemblid_filter, character string describing the biomart ensembl id filter to use, required
#' @param biomart_genesymbol_attribute, character string describing the biomart gene symbol attribute to obtain, required
#' @return annotated dataframe
#' @seealso \code{\link{biomaRt}} used to annotate the dataframe
#' @export
#' @examples
#' annotate_df(temp, "id", 'mmusculus_gene_ensembl', "ensembl_gene_id", "mgi_symbol")
annotate_df = function(df, df_ensemblid_header, biomart_ensembl_dataset, biomart_ensemblid_filter, biomart_genesymbol_attribute) {
  require(biomaRt)
  ensembl = useMart('ENSEMBL_MART_ENSEMBL', dataset = biomart_ensembl_dataset, host="useast.ensembl.org")
  annot.df = getBM(attributes=c(biomart_ensemblid_filter, biomart_genesymbol_attribute, "description"),
            filters=c(biomart_ensemblid_filter), values=as.character(df[, df_ensemblid_header]),
            mart=ensembl)
  m = merge(df, annot.df, by.x=df_ensemblid_header, by.y=biomart_ensemblid_filter, all.x=T)
  return(m)
}


#' Get biomart annotation from id
#'
#' @param v vector of ids
#' @param type character name to get from biomart
#' @param id character defining what kind of id is provided
#' @param dataset specie database to connect to biomart
#' @return annotated vector in the same order
#' @seealso \code{\link{biomaRt}} used to annotate the dataframe
#' @export
#' @examples
#' get_biomrt(v, "gene_biotype")
get_biomart = function(v, type="description", id="ensembl_gene_id",
                       dataset="hsapiens_gene_ensembl")
{
  require(biomaRt)
  v = as.character(v)
  v[is.na(v)] = "None"
  mart = useMart("ENSEMBL_MART_ENSEMBL", dataset, host="www.ensembl.org")
  g <- getBM( attributes=c(id,type) , filters=
                id, values =as.character(v) ,mart=mart)
  out <- rep("", length(v))
  idx <- match(g[,1], v)
  out[idx] <- g[,2]
  names(out[idx]) <- g[,1]
  out
}

#' Get other Ids for genes in the same order
#'
#' @param ids, character vector of gene ids
#' @param from, type of ID of ids vector
#' @param to, type of ID to convert
#' @param db, org.species.eg.db class
#' @param ifMultiple, what to do when multiple possibles IDs
#' @return annotated dataframe
#' @seealso \code{\link{AnnotationDbi::select}} used to annotate the dataframe
#' @export
#' @examples
#' convertIDs(list_genes, "ENSEMBLTRANS", "SYMBOL", org.Mm.eg.db, "useFirst")
convertIDs <- function( ids, from, to, db, ifMultiple=c("putNA", "useFirst")) {
  # stopifnot( inherits( db, "AnnotationDb" ) )
  ifMultiple <- match.arg( ifMultiple )
  if (sum(ids %in% keys(db, from))==0)
    return(ids)
  suppressMessages( selRes <- AnnotationDbi::select(
    db, keys=ids, keytype=from, columns=c(from,to) ) )
  if ( ifMultiple == "putNA" ) {
    duplicatedIds <- selRes[ duplicated( selRes[,from] ), from ]
    selRes <- selRes[ ! selRes[,from] %in% duplicatedIds, ]
  }
  return( selRes[ match( ids, selRes[,from] ), to ] )
}

i_create_fastqc_figure<-function(path,samples,out){
  require(ggplot2)
  require(Nozzle.R1)
  ############QUALITY PER NT###############
  tfqc<-data.frame()
  for (f in samples){
    src<-paste(path,f,"/qc/fastqc/fastqc_data.txt",sep="")
    endnt<-system(paste("grep -n END ",src," | head -2 | tail -1| sed 's/:/\t/' | cut -f 1"),
                  intern = TRUE)
    endnt<-as.integer(endnt)
    fqc<-suppressMessages(read.table(src,nrows=endnt-14,skip=12,sep="\t"))
    names(fqc)<-c("nt","mean","median","lowQ","upQ","10Q","90Q")
    fqc$sample<-substr(f,1,21)
    tfqc<-rbind(tfqc,fqc)
    
  }
  tfqcFile<-paste(out,"tfqc.txt",sep="")
  write.table(tfqc,tfqcFile,row.names=F,quote=F,sep="\t")
  
  
  p<-ggplot(tfqc,aes(factor(nt),mean)) +
    #geom_boxplot() + 
    geom_jitter(position=position_jitter(width=0.3),aes(factor(nt), mean,colour=factor(sample)))+
    geom_abline(intercept = 30,slope=0)+
    ylim(25,42)+
    theme_bw(base_size = 12) +
    theme(axis.text.x = element_blank())+
    labs(list(x="nucleotide",y="score",colour="Samples"))
  
  
  ffqcFile="ffqc.jpg"
  ffqcHFile="ffqcH.pdf"
  jpeg(paste(out, ffqcFile, sep="" ) ,width=600,height=400,quality=100 );
  print(p)
  dev.off();
  pdf(paste( out, ffqcHFile, sep="" )  );
  print(p)
  dev.off();
  
  # create a figure and make it available for exporting
  FRfqc <- newFigure( ffqcFile, fileHighRes=ffqcHFile, exportId="FIGURE_FASTQC",
                      "This figure shows the quality per nucleotide for each sample.
                      Any value above 30 is quite good quality." );
  ################################################
  return(FRfqc)
}

i_create_rnaseqc_figure<-function(path,samples,out){
  require(ggplot2)
  require(Nozzle.R1)
  
  ############COVERAGE###############
  
  trqccov<-data.frame()
  for (f in samples){
    print (f)
    src<-paste(path,f,"/qc/rnaseqc/meanCoverageNorm_low.txt",sep="")
    temp<-read.table(src,skip=1)
    temp$type<-"low"
    temp$pos<-1:nrow(temp)
    temp$sample<-substr(f,1,21)
    trqccov<-rbind(trqccov,temp)
    src<-paste(path,f,"/qc/rnaseqc/meanCoverageNorm_medium.txt",sep="")
    temp<-read.table(src,skip=1)
    temp$type<-"medium"
    temp$pos<-1:nrow(temp)
    temp$sample<-substr(f,1,21)
    trqccov<-rbind(trqccov,temp)
    src<-paste(path,f,"/qc/rnaseqc/meanCoverageNorm_high.txt",sep="")
    temp<-read.table(src,skip=1)
    temp$type<-"high"
    temp$pos<-1:nrow(temp)
    temp$sample<-substr(f,1,21)
    trqccov<-rbind(trqccov,temp)
    
  }
  
  trqccovFile<-paste(out,"trqccov.txt",sep="")
  write.table(trqccov,trqccovFile,row.names=F,quote=F,sep="\t")
  
  trqccov$type<-factor(trqccov$type,levels=c("low","medium","high"))
  p<-ggplot(trqccov,aes(pos,log2(V1+0.5),colour=sample)) +
    geom_line()+
    theme_bw(base_size = 12) +
    theme(axis.text.x = element_blank())+
    labs(list(x="gene",y="coverage",colour="Samples"))+
    facet_wrap(~type,nrow=3)
  
  
  stdFile="frqccov.jpg"
  highFile= "frqccovH.jpg"
  jpeg( paste( out,stdFile , sep="" ),width=600,height=400,quality=100 );
  print(p)
  dev.off(frqccovFile);
  pdf( paste( out, highFile, sep="" ));
  print(p)
  dev.off();
  
  # create a figure and make it available for exporting
  FIG <- newFigure( stdFile, fileHighRes=highFile,exportId="FIGURE_COV",
                         "This shows the gene coverage by reads. 
                    A good signal is an equal coverage along gene." );
  ################################################
  return(FIG)
  
}

i_create_gene_coverage<-function(path,samples,out){
  require(ggplot2)
  require(Nozzle.R1)
  
  ############COVERAGE###############
  trqccov<-data.frame()
  for (f in samples){
    src<-paste(path,f,"/qc/rnaseqc/meanCoverageNorm_low.txt",sep="")
    temp<-read.table(src,skip=1)
    temp$type<-"low"
    temp$pos<-1:nrow(temp)
    temp$sample<-substr(f,1,21)
    trqccov<-rbind(trqccov,temp)
    src<-paste(path,f,"/qc/rnaseqc/meanCoverageNorm_medium.txt",sep="")
    temp<-read.table(src,skip=1)
    temp$type<-"medium"
    temp$pos<-1:nrow(temp)
    temp$sample<-substr(f,1,21)
    trqccov<-rbind(trqccov,temp)
    src<-paste(path,f,"/qc/rnaseqc/meanCoverageNorm_high.txt",sep="")
    temp<-read.table(src,skip=1)
    temp$type<-"high"
    temp$pos<-1:nrow(temp)
    temp$sample<-substr(f,1,21)
    trqccov<-rbind(trqccov,temp)
    
  }
  
  trqccovFile<-paste(out,"trqccov.txt",sep="")
  write.table(trqccov,trqccovFile,row.names=F,quote=F,sep="\t")
  
  trqccov$type<-factor(trqccov$type,levels=c("low","medium","high"))
  p<-ggplot(trqccov,aes(pos,log2(V1+0.5),colour=sample)) +
    geom_line()+
    theme_bw(base_size = 12) +
    theme(axis.text.x = element_blank())+
    labs(list(x="gene",y="coverage",colour="Samples"))+
    facet_wrap(~type,nrow=3)
  
  
  stdFile="frqccov.jpg"
  highFile="frqccovH.pdf"
  jpeg( paste( out ,stdFile , sep="" ) ,width=600,height=400,quality=100 );
  print(p)
  dev.off();
  pdf( paste( out , highFile, sep="" ) );
  print(p)
  dev.off();
  
  # create a figure and make it available for exporting
  FIG <- newFigure( stdFile, fileHighRes=highFile,exportId="FIGURE_COV",
                         "This shows the gene coverage by reads. 
                    A good signal is an equal coverage along the gene." );
  ################################################
  
  return(FIG)
}

i_create_count_top<-function(path,ssamples,out){
  require(Nozzle.R1)
  
  mainfolder<-dir(path,pattern="project")
  ############COUNTS###############
  counts<-read.table(paste(sep="",path,mainfolder,"/annotated_combined.counts"),header=T,sep="\t")
  names(counts)<-substr(names(counts),1,21)
  counts$mean<-rowMeans(counts[,2:(ncol(counts)-1)])
  counts<-counts[order(-counts$mean),]
  counts<-counts[counts$mean>0,]
  
  countsFile<-"counts.txt"
  write.table(counts,paste(out,countsFile,sep=""),row.names=F,quote=F,sep="\t")
  short<-counts[1:30,]
  TAB <- newTable(short , file=countsFile, exportId="TABLE_COUNTS",
                      "Top genes" );
  
  return(TAB)
}

i_create_distribution_counts<-function(path,samples,out,condition){
  require(ggplot2)
  require(Nozzle.R1)
  require(reshape)
  require(DESeq2)
  
  mainfolder<-dir(path,pattern="project")
  
  counts<-read.table(paste(sep="",path,mainfolder,"/combined.counts"),header=T,row.names=1,sep="\t")
  names(counts)<-substr(names(counts),1,21)
  keep<-rowSums(counts>0)>=1
  counts<-counts[keep,]
  cshape<-suppressMessages(melt(counts,by=1))
  p<-ggplot(cshape,aes(factor(variable),log2(value+0.1))) +
    geom_boxplot() + 
    theme_bw(base_size = 12) +
    theme(axis.text.x = element_blank()) +
    labs(list(x="",y="log2(raw counts)"))
  
  stdFile= "cbox.jpg"
  jpeg( paste( out,stdFile, sep="" ),width=600,height=400,quality=100 );
  print(p)
  dev.off();
  
  # create a figure and make it available for exporting
  FIG1 <- newFigure( stdFile,exportId="FIGURE_COUNTS",
                    "Distribution of raw counts" );
  
  ma<-counts
  design<-data.frame(row.names=names(ma),condition=condition)
  dse<-DESeqDataSetFromMatrix(countData = ma,
                              design=~condition,
                              colData=design)
  rld<-rlogTransformation(dse)
  p<-ggplot(suppressMessages(melt(assay(rld))),aes(factor(X2),value)) +
    geom_boxplot() + 
    theme_bw(base_size = 12) +
    theme(axis.text.x = element_blank())+
    labs(list(x="",y="log2(normalized counts)"))
  
  stdFile= "cboxnorm.jpg"
  jpeg( paste( out,stdFile, sep="" ),width=600,height=400,quality=100 );
  print(p)
  dev.off();
  
  # create a figure and make it available for exporting
  FIG2 <- newFigure( stdFile,exportId="FIGURE_COUNTSNORM",
                           "Distribution of normalized counts" );
  
  cum<-assay(rld)
  cum<-as.data.frame(apply(cum,2,sort))
  cum$pos<-nrow(cum):1
  cum<- suppressMessages(melt(cum,id.vars="pos"))
  p<-ggplot(cum,aes(pos,value,colour=variable)) +
    geom_point() +
    theme_bw(base_size = 12) +
    labs(list(x="sorted genes",y="log2(normalized counts)"))
  
  sdtFile="fcum.jpg"
  highFile="fcumH.pdf"
  jpeg(paste( out,sdtFile , sep="" ) ,width=600,height=400,quality=100 );
  print(p)
  dev.off()
  pdf( paste( out, highFile, sep="" ) )
  print(p)
  dev.off()
  
  # create a figure and make it available for exporting
  FIG3<- newFigure( sdtFile, fileHighRes=highFile,exportId="FIGURE_CUM",
                       "Cumulative expression by sample." )
  

  p<-mds(assay(rld),condition)
  p<-p + theme_bw(base_size = 12) +
    geom_text(aes(one,two,label=label))+
    scale_color_brewer(palette="Set1")
  
  stdFile= "mds.jpg"
  jpeg( paste( out,stdFile, sep="" ),width=600,height=400,quality=100 )
  print(p)
  dev.off()
  
  # create a figure and make it available for exporting
  FIG4 <- newFigure( stdFile,exportId="FIGURE_MDS",
                       "Multidimensional scaling plot" );
  
  
  return(list(FIG1,FIG2,FIG3,FIG4))
  
}

i_create_mapping_stats<-function(path,samples,out){
  require(Nozzle.R1)
  
  ############ALIGNED#################
  trqc<-data.frame()
  for (f in samples){
    src<-paste(path,f,"/qc/rnaseqc/metrics.tsv",sep="")
    rqc<-read.table(src,sep="\t",skip=1)
    rqc$sample<-substr(f,1,21)
    trqc<-rbind(trqc,rqc)
  }
  
  trqc<-trqc[,c(1,19,17,8,20,23,7,38)]
  names(trqc)<-c("Sample","Total","Mapped","Mapping rate","rRNA","transcripts","Exonic rate","Bases MM rate")
  
  tFile<-"trqc.txt"
  write.table(trqc,paste(out,tFile,sep=""),row.names=F,quote=F,sep="\t")
  
  # create a table and make it available for exporting
  TAB <- newTable( trqc, file=tFile, exportId="TABLE_RNASEQC",
                    "Stats of mapping reads " );
  
  
  ################################################
  
  return(TAB)
  
}

## first import the gene model (gtf/gff) into the R envirnoment as a TranscriptDb object using import.gtf2db
## should work with either gtf or gff formats
import.gtf2db <- function(genemodel.file, exonnumber.attribute=NULL,...){
  require(GenomicFeatures) 
  require(tools)
  file.format <- file_ext(genemodel.file)
  makeTranscriptDbFromGFF(file=genemodel.file, format=file.format, exonRankAttributeName=exonnumber.attribute, dataSource=NA, species=NA)
}

## next, pass the TranscriptDb object describing your transcripts to the plotting function, along with:
# gene.of.interest <- the gene of interest, currently this uses the gene symbol to specify the gene, (character)
# genemodel.db <- the genemodel (TranscriptDb object)
# genome.build  <-  genome build (character) eg. "hg19"
# bam.files  <-  named list of the bam files (list) eg. list(bam1="/foo1/bar1.bam", bam2="foo2/bar2.bam")
# plotcoverage <- whether to plot coverage graph (logical)
# plotreads  <-  whether to plot reads (logical)
plot.cov.reads.gene <- function(gene.of.interest="GAPDH", genemodel.db, genome.build, bam.files, plotcoverage=TRUE, plotreads=TRUE) {
  ## using Gviz to visualize an RNA-seq alignment for genes of choice
  require(Gviz)
  require(GenomicFeatures)  
  require(Rsamtools)
  flattenlist <- function(x) {
    y <- list()
    rapply(x, function(x) y <<- c(y,x))
    return(y)
  }
  cbPalette <- rep(c("#999999", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7", "#000000"), 4)
  # index alignments if necessary
  lapply(bam.files, function(bam.file){
    if(!file.exists(paste(bam.file, "bai", sep="."))){indexBam(bam.file)}
  })
  ## gene location infomation
  chr <-select(genemodel.db, keys=gene.of.interest, cols="TXCHROM" , keytype="GENEID")[[2]]
  start <- select(genemodel.db, keys=gene.of.interest, cols="TXSTART", keytype="GENEID")[[2]]
  end <- select(genemodel.db, keys=gene.of.interest, cols="TXEND", keytype="GENEID")[[2]]
  ##PREP tracks
  ## Genome Axis and chromosom ideogram track
  gtrack <- GenomeAxisTrack()
  itrack <- IdeogramTrack(chromosome=chr, genome=genome.build)
  ## make GeneRegionTrack from genemodel
  grtrack <- GeneRegionTrack(genemodel.db)
  # stream bam files to determine maximum coverage
  selection.gr <- GRanges(seqnames=chr, ranges=IRanges(start=start, end=end))
  param <- ScanBamParam(what=c("pos", "qwidth"), which=selection.gr, flag=scanBamFlag(isUnmappedQuery=FALSE))
  ymax <- 0
  for (bam.file in bam.files){
    x <- scanBam(bam.file, param=param)[[1]]
    cov <- coverage(IRanges(x[["pos"]], width=x[["qwidth"]]))
    if(max(cov)>ymax){ymax <- max(cov)}
  }
  # stream bam file to get reads and coverage for each alignment (assign different color to each alignment)
  align.tracks <- list()
  for (sample in names(bam.files)) {
    n <- which(names(bam.files)==sample)
    label.readtrack <- paste("reads", sample, sep=".")
    label.covtrack <- paste("coverage", sample, sep=".")
    if (plotcoverage==TRUE){
      align.tracks[[label.covtrack]] <- DataTrack(range=bam.files[[sample]], genome=genome.build, type="l",  window=-1, chromosome=chr, col="red", lwd=2, name=" ", background.title = cbPalette[n],  grid=T, col.frame="red", ylim=c(0,ymax))
    }
    if (plotreads==TRUE){
      align.tracks[[label.readtrack]] <- AnnotationTrack(range = bam.files[[sample]], genome = genome.build, chromosome = "chr19", name=sample, background.title = cbPalette[n])
    }
  }
  ## assemble tracks
  tracks <-  list(itrack, gtrack, grtrack, align.tracks) 
  tracks <- flattenlist(tracks)
  ## plot tracks
  plotTracks(tracks, from=start, to=end, chromosome=chr, extend.left=100, extend.right=100)
}

fmt <- function(){
    function(x) format(x,nsmall = 1,scientific = FALSE)
}
#' Create volcano plot from log2FC and adjusted pvalues data frame
#'
#' @param stats data.frame with two columns: logFC and Adjusted.Pvalue
#' @param side plot UP, DOWN or BOTH de-regulated points
#' @param title title for the figure
#' @param pval.cutoff cutoff for the adjusted pvalue. Default 0.05
#' @param lfc.cutoff cutoff for the log2FC. Default 1
#' @param shade.alpha transparency value. Default 0.25
#' @param point.colour colours for points. Default gray
#' @param point.alpha transparency for points. Default 0.75
#' @param point.outline.colour Default darkgray
#' @param line.colour Defaul gray
#' @param plot_text data.frame similar to stats table, with a third column
#' being the text you want to add next to the point in the volcano plot. Default NULL
#' @export
volcano_density_plot <- function(stats, side="both", title="Volcano Plot with Marginal Distributions",
                                 pval.cutoff=0.05, lfc.cutoff=1, shade.colour="green",
                                 shade.alpha=0.25, point.colour="gray", point.alpha=0.75,
                                 point.outline.colour="darkgray", line.colour="gray", plot_text=NULL) {
    require(grid)
    require(gridExtra)
    require(ggplot2)
    if ( !any(side %in% c("both","down","up")) | length(side)>1)
        stop("side parameter should be: both, up or down.")
    if (ncol(stats)!=2)
        stop("Need a data.frame with two columns: logFC and Adjusted.Pvalue")
    if ( sum( rowSums(is.na(stats)) ) > 0 )
        stats = stats[rowSums(is.na(stats))==0,]
    if ( any(stats[,2]>1) | any(stats[,2]<0) )
        stop("pvalues needs to be >0 and <1")
    names(stats) = c("logFC","adj.P.Val")
    stats[,2] = stats[,2] + 1e-10
    # get range of log fold change and p-value values to setup plot borders
    range.lfc <- c(floor(min(stats$logFC))-1, ceiling(max(stats$logFC))+1)
    range.pval <- c(floor(min(-log10(stats$adj.P.Val))), ceiling(max(-log10(stats$adj.P.Val)))+1)

    #make top plot - density plot with fold changes
    lfcd <- as.data.frame(cbind(density(stats$logFC)$x, density(stats$logFC)$y))
    hist_top <- ggplot(data=stats, aes(x=logFC))+
        geom_density(color=line.colour)+
        theme_bw()+
        theme(axis.title.x=element_blank())+
        theme(plot.margin=unit(c(3,-5.5,4,3), "mm") )+
        scale_x_continuous(limits = range.lfc, breaks = range.lfc[1]:range.lfc[2], expand = c(.05,.05))+
        scale_y_continuous(labels=fmt()) + labs(list(title="fold changes density plot"))
    if (side=="both" | side=="up")
        hist_top = hist_top + geom_ribbon(data=subset(lfcd, V1>lfc.cutoff),aes(x=V1,ymax=V2),ymin=0,fill=shade.colour, alpha=shade.alpha)
    if (side=="both" | side=="down")
        hist_top = hist_top +  geom_ribbon(data=subset(lfcd, V1< -lfc.cutoff),aes(x=V1,ymax=V2),ymin=0,fill=shade.colour, alpha=shade.alpha)


    # make blank plot
    empty <- ggplot()+geom_point(aes(1,1), colour="white")+
        theme(panel.grid=element_blank(),
              axis.ticks=element_blank(),
              panel.background=element_blank(),
              axis.text.x=element_blank(),
              axis.text.y=element_blank(),
              axis.title.x=element_blank(),
              axis.title.y=element_blank()
        )

    #make scatter volcano plot
    scat.poly.up <- with(stats, data.frame(x=as.numeric(c(lfc.cutoff,  lfc.cutoff, max(range.lfc),max(range.lfc))), y=as.numeric(c(-log10(pval.cutoff), max(range.pval), max(range.pval),-log10(pval.cutoff)))))
    scat.poly.down <- with(stats, data.frame(x=as.numeric(c(-lfc.cutoff,  -lfc.cutoff, min(range.lfc),min(range.lfc))), y=as.numeric(c(-log10(pval.cutoff), max(range.pval), max(range.pval),-log10(pval.cutoff)))))
    scatter <- ggplot(data=stats, aes(x=logFC, y=-log10(adj.P.Val))) +
        geom_point(alpha=point.alpha, pch=21, fill=point.colour, color=point.outline.colour) +
        xlab("log2 fold change") + ylab("-log10(adjusted p-value)") +
        theme_bw()+
        theme(legend.position="none") +
        theme(plot.margin=unit(c(3,-5.5,4,3), "mm") )+
        scale_x_continuous(limits = range.lfc, breaks = range.lfc[1]:range.lfc[2], expand = c(.05,.05))+
        scale_y_continuous(labels=fmt(), limits = range.pval)+ labs(list(title="Volcano plot"))
    if (side=="both" | side=="up")
        scatter = scatter + geom_polygon(data=scat.poly.up, aes(x=x,y=y), fill=shade.colour, alpha=shade.alpha)
    if (side=="both" | side=="down")
        scatter = scatter + geom_polygon(data=scat.poly.down, aes(x=x,y=y), fill=shade.colour, alpha=shade.alpha)
    if (!is.null(plot_text)){
        require(ggrepel)
        names(plot_text) = c("logFC", "adj.P.Val", "name")
        plot_text[,2] <- plot_text[,2] + 1e-10
        scatter <- scatter + 
            geom_text_repel(data=plot_text, aes(x=logFC, y=-log10(adj.P.Val), label=name), size=3)
    }
        
        
    # make right plot - density plot of adjusted pvalues
    pvald <- as.data.frame(cbind(density(-log10(stats$adj.P.Val))$x, density(-log10(stats$adj.P.Val))$y))
    hist_right <- ggplot(data=stats, aes(x=-log10(adj.P.Val)))+
        geom_density(color=line.colour)+
        geom_ribbon(data=subset(pvald, V1>-log10(pval.cutoff)),aes(x=V1,ymax=V2),ymin=0,fill=shade.colour, alpha=shade.alpha)+
        theme_bw()+coord_flip()+
        scale_x_continuous(limits = range.pval)+
        theme(axis.title.y=element_blank())+
        theme(plot.margin=unit(c(3,-5.5,4,3), "mm")) + labs(list(title="adj.pval density plot"))

    # plot all plots
    pp.logfc <- ggplotGrob(hist_top)
    pp.empty <- ggplotGrob(empty)
    pp.volc <- ggplotGrob(scatter)
    pp.pval  <- ggplotGrob(hist_right)
    p = grid.arrange(top=textGrob(title),
                 arrangeGrob(pp.logfc,pp.volc, heights=c(1,3),ncol=1),
                 arrangeGrob(pp.empty,pp.pval,  heights=c(1,3),ncol=1),
                 ncol=2, widths=c(3,1))
    invisible(p)
}

#' Pairwise Principal Component Analysis Plots of CountDataSet objects
#'
#' @param countdataset CountDataSet, required
#' @param categories character string, column header of column containing different categories to highlight with colors, required
#' @param categories2 character string, column header of column containing different categories to highlight with shapes, optional
#' @param title character string, title for the plot, required
#' @param colorpalette charcter vector of RGB colors (long enough for a color per category), required
#' @param alpha alpha shading from 0 (transparent) to 1 (opaque), defaults to 1
#' @param numcomponents number of principal components to plot, defaults to 4 
#' @return pairwise plots of samples plotted by principal component
#' @seealso \code{\link{pair}} which this function uses to plot all pairwise combos
#' @export
#' @examples
#' PCAplot.cds(countdataset=cds, categories="condition", title="PCAplot", colorpalette=c("#FF0000", "#00FF00", "#0000FF"), alpha=0.8, numcomponents=4)

PCAplot.cds <- function(countdataset, categories, categories2, title, colorpalette, alpha=1, numcomponents=4, normalize.counts=TRUE){
  # check for missing options
  if (missing(countdataset)){
    stop("Function requires an CountDataSet")
  }
  if(missing(categories)){
    stop("Function requires you to specify phenoData column name (as categories to highlight)")
  }
  if(missing(title)){
    stop("Function requires you to specify a title for plot")
  }
  if (missing(colorpalette)){
    stop("Function requires you to specify a colorpalette")
  }
    # get metadata
  pd <- pData(countdataset)
  if (!missing(categories2) & length(unique(as.character(unlist(pd[,categories2]))))>5){
    stop("Only 5 unique types allowed for secondary category")
  }
  
  # set colors and alphas
  alpha <- sprintf("%x", ceiling(alpha*255))
  colorpalette <- paste(colorpalette, alpha, sep="")
  colors <- colorpalette[factor(as.character(unlist(pd[,categories])))]
  # normalize data if requested
  if (normalize.counts){
    df <- counts(countdataset, normalized=TRUE)
  } else {
    df <- counts(countdataset, normalized=FALSE)
  }
  if(missing(categories2)){
    shapes <- rep(21, length(categories))
  } else {
    numcat2s <- length(unique(as.character(unlist(pd[,categories2])))) 
    shapes <- c(21:25)[1:numcat2s][factor(as.character(unlist(pd[,categories2])))]
  }
  
  # run the actual PCA
  myPca.core <- prcomp(t(df))
  tmpPCAData.core <- as.data.frame(myPca.core$x[,1:numcomponents])
  # plot the result
  if(!missing(categories2)){
    pairs(tmpPCAData.core, bg=colors, col="#606060", cex=2, pch=shapes, main=title, oma=c(8,5,5,14))
    legend("right", cex=0.7, col="#606060", pt.bg=colors, pt.cex=1.5, legend=paste(pd[,categories], pd[,categories2], sep="-"),  pch=shapes, bty="n", x.intersp=1)
  } else {
    pairs(tmpPCAData.core, bg=colors, col="#606060", cex=2, pch=21, main=title, oma=c(8,5,5,14))
    legend("right", cex=0.7, col="#606060", pt.bg=colors, pt.cex=1.5, legend=pd[,categories],  pch=21, bty="n", x.intersp=1)
  }
}
  

#' MDS (MultiDimensional Scaling) Plots
#'
#' @param dat object, RGChannelSet, required
#' @param numPositions, integer, number of most variable positions to use for MDS, defaults to 1000
#' @param sampGroups, chracter string, column name in phenoData of RGset containing groups for coloring groups on  plot, required
#' @param sampNames, chracter string , column name in phenoData of RGset containing sample labels for plot, optional
#' @param main chracter string, title for the plot, defaults to "MDSplot"
#' @param alpha floating point, alpha shading from 0 (transparent) to 1 (opaque), defaults to 1
#' @param cex integer, size of points in plot, defaults to 1 
#' @return plot of samples plotted by MDS
#' @seealso \code{\link{cmdscale}} which this function uses to calculate MDS
#' @export
#' @examples
#' mdsplot.RGset(dat=RGset, numPositions=1000, sampGroups="groups", sampNames="sampleIDs", main="MDSplot", alpha=0.8, cex=10)

mdsplot.RGset <- function (dat, numPositions = 1000, sampGroups, sampNames, main = "MDS plot", alpha=1, cex=1) {
  if (missing(dat)){
    stop("data required")
  }
  if (missing(sampGroups)){
    stop("sampGroups required")
  }
  # get beta values
  b <- getBeta(dat)
  pd <- pData(dat)
  # reorder and subset to most variable rows
  o <- order(-rowVars(b))[1:numPositions]
  # calculate euclidean distances  
  d <- dist(t(b[o, ]))
  # mds
  fit <- cmdscale(d)
  # prep for ggplot
  fit <- as.data.frame(fit)
  names(fit) <- c("x", "y")
  # merge in phenoDAta to mds fit data
  fit <- cbind(fit, pd)
  # generate color factors for ggplot
  fit$col <- fit[,sampGroups]
  fit$col <- as.character(fit$col)
  fit <- as.data.frame(fit) # Required again as new minfi returns DataFrame class, not data.frame
  # factor colors in palette by sampGroups
  if (missing(sampNames)) {
    ggplot(fit, aes(x=x, y=y, color=col))+
      geom_point(size=cex, alpha=alpha)+
      ggtitle(main)+
      scale_color_discrete(name="Experimental\nCondition")+
      scale_x_continuous(name="")+
      scale_y_continuous(name="")
  }  else {
    fit$labels <- factor(pd[,sampNames])
    ggplot(fit, aes(x=x, y=y, color=col))+
      geom_point(size=cex, alpha=alpha)+
      ggtitle(main)+
      geom_text(data = fit, aes(x,y, label = labels), hjust = 2)+
      scale_color_discrete(name="Experimental\nCondition")+
      scale_x_continuous(name="")+
      scale_y_continuous(name="")
  }
}

ggROC = function(df, facetName, groupName = "grp", predName = "res") {
  require(plyr)
  require(ggplot2)
  df = df[complete.cases(df),]
  plotdata = ddply(df, facetName,
      function(x) data.frame(roc(x[,groupName], x[,predName])[c("sensitivities",
                                                            "specificities")]))
  plotdata$specificities = 1 - plotdata$specificities
  colnames(plotdata) = c(facetName, "tpr", "fpr")
  p = ggplot(plotdata, aes(fpr, tpr)) + 
      geom_line(aes_string(colour=facetName))
  return(p)
}

#' add a column to a dataframe consisting of the current rownames
#'
#' @param df dataframe
#' @param colname character vector specifying new column id
#' @return dataframe with rownames as a column
#' @export
#' @examples
#' rownamess2col(dataframe, "newcolumnid")


####################################
row2colnames <- function(df, colname) {
  output <- cbind(row.names(df), df)
  colnames(output)[1] <- colname
  return(output)
}

#' add a column to a dataframe consisting of the current rownames
#'
#' @param df dataframe
#' @param colname character vector specifying id of column with new rownames
#' @param removecol boolean specifying wheter to remove the column used to rename rownames
#' @return dataframe with column contents as rownames
#' @export
#' @examples
#' col2rownames(dataframe, "columnid", FALSE)


####################################
col2rownames <- function(df, colname, removecol=TRUE) {
  output <- df
  row.names(output) <- output[,colname]
  if (removecol) {
    output[,colname] <- NULL
  }
  return(output)
}

#' Plot MDS
#'
#' @param counts  matrix
#' @param condition  vector indicating the group of each sample
#' @param k  number of dimension
#' @param d distance method (euclidian, cor)
#' @param xi PC for x-axis (1 to k)
#' @param yi PC for y-axis (1 to k)
#' @export
mds = function(counts, condition=NULL,k=6,d="euclidian",xi=1,yi=2) {
    require(ggplot2)
    nprobes = nrow(counts)
    nsamples = ncol(counts)
    if (d=="euclidian"){
     distances = dist(t(counts))
    }else if (d=="cor"){
      distances = as.dist(1-cor(counts))
    }
    fit = cmdscale(distances, eig=TRUE, k=k)
    #names = c("one", "two", "three", "four", "five", "six")
    #colnames(fit$points) = names[1:k]
    eigs = data.frame(variance_explained=fit$eig / sum(fit$eig))
    xnames = paste0("PC",1:k," ",round(eigs[1:k,1]*100,digits=2),"%")
    df = as.data.frame(fit$points[,c(xi,yi)])
    names(df) = c("one", "two")
    df$label = rownames(df)
    if(!is.null(condition)) { 
        df$condition = condition
        p = ggplot(df, aes(one, two, label=label, color=condition)) +
            geom_text(aes(one, two, label=label), size=3) +
            labs(list(x=xnames[xi],y=xnames[yi])) +
            scale_x_continuous(expand=c(0.3, 0.3))
    }
    else {
        p = ggplot(df, aes(one, two)) +
            geom_text(aes(one, two, label=label), size=3) +
            labs(list(x=xnames[xi],y=xnames[yi])) + scale_x_continuous(expand=c(0.3, 0.3))
            
    }
        
    return(p)
}

#' Plot PC importance
#'
#' @param counts  matrix
#' @param k  number of dimension
#' @param d distance method (euclidian, cor)
#' @export
variance_by_component = function(counts,k=6,d="euclidian") {
    nsamples = ncol(counts)
    if (d=="euclidian"){
      distances = dist(t(counts))
    }else if (d=="cor"){
      distances = as.dist(1-cor(counts))
    }
    fit = cmdscale(distances, eig=TRUE, k=k)
    eigs = data.frame(variance_explained=fit$eig / sum(fit$eig))
    eigs$component = factor(rownames(eigs), levels=rownames(eigs))
    p = ggplot(eigs, aes(component, variance_explained)) + geom_point() +
            ylab("variance explained") +
            xlab("principal component")
    return(p)
}

PCAplot.eset <- function(eset=NULL, categories=NULL, title=NULL, colorpalette=NULL, alpha=1, numcomponents=4){
  alpha <- sprintf("%x", ceiling(alpha*255))
  colorpalette <- paste(colorpalette, alpha, sep="")
  eset.core <- exprs(eset) 
  myPca.core <- prcomp(t(eset.core))
  tmpPCAData.core <- as.data.frame(myPca.core$x[,1:numcomponents])
  pd <- pData(eset)
  colors <- colorpalette[factor(as.character(unlist(pd[,categories])))]
  legend_values=unique(cbind(colors, as.character(pd[,categories])))
  pairs(tmpPCAData.core, bg=colors, col="#606060", cex=2, pch=21, main=title, oma=c(8,5,5,14))
  legend("right", cex=0.7, col="#606060", pt.bg=legend_values[,1], pt.cex=1.5, legend=legend_values[,2],  pch=21, bty="n", x.intersp=1)
}

####################################
PCAplot.df <- function(df=NULL, meta.df=NULL, categories=NULL, title=NULL, colorpalette=NULL, alpha=1, numcomponents=6){
  alpha <- sprintf("%x", ceiling(alpha*255))
  colorpalette <- paste(colorpalette, alpha, sep="")
  myPca.core <- prcomp(t(df))
  tmpPCAData.core <- as.data.frame(myPca.core$x[,1:numcomponents])
  # SD of components
  colors <- colorpalette[factor(as.character(unlist(meta.df[,categories])))]
  legend_values=unique(cbind(colors, as.character(meta.df[,categories])))
  pairs(tmpPCAData.core, bg=colors, col="#606060", cex=2, pch=21, main=title, oma=c(8,5,5,14))
  legend("right", cex=0.7, col="#606060", pt.bg=legend_values[,1], pt.cex=1.5, legend=legend_values[,2],  pch=21, bty="n", x.intersp=1)
}

####################################
PCAplot.sd.eset <- function(eset=NULL,  title=NULL){
  eset.core <- exprs(eset)
  myPca.core <- prcomp(t(eset.core))
  # SD of components
  sdevdf <- data.frame(cbind(as.numeric(myPca.core$sdev),c(1:length(myPca.core$sdev))))
  sdevdf$prop <-  sdevdf$X1/sum(sdevdf$X1)
  sdevdf$cum <- cumsum(sdevdf$prop)
  ggplot(sdevdf, aes(x=X2, y=prop)) + 
    geom_point(size=4, color="red") + 
    scale_x_continuous('Component') + 
    scale_y_continuous('Standard Deviation') +
    ggtitle(title) +
    geom_line(data=sdevdf, aes(x=X2, y=cum))
}

####################################
PCAplot.sd.df <- function(eset=NULL, title=NULL){
  myPca.core <- prcomp(t(df))
  # SD of components
  sdevdf <- data.frame(cbind(as.numeric(myPca.core$sdev),c(1:length(myPca.core$sdev))))
  sdevdf$prop <-  sdevdf$X1/sum(sdevdf$X1)
  sdevdf$cum <- cumsum(sdevdf$prop)
  ggplot(sdevdf, aes(x=X2, y=prop)) + 
    geom_point(size=4, color="red") + 
    scale_x_continuous('Component') + 
    scale_y_continuous('Standard Deviation') +
    ggtitle(title) +
    geom_line(data=sdevdf, aes(x=X2, y=cum))
}

#' Cel file IDs of intensity boxplot outlier arrays (in characters).
#'
#' @param eset GeneFeatureSetm, AffyBatch or ExpressionSet object
#' @param logtransform Boolean, log transform data before processing?
#' @return character vector of arrays (CEL file IDs) that are outliers for intensity boxplots.
#' @seealso \code{\link{arrayQualityMetrics}} which this function subsets
#' @export
#' @examples
#' boxplotoutliers(eset=AffyRaw, logtransform=TRUE)s

boxplotoutliers <- function(eset=NULL, logtransform=TRUE){
  require(arrayQualityMetrics)
  preparedData=prepdata(expressionset=eset, intgroup=NULL, do.logtransform=TRUE)
  boxplot<-aqm.boxplot(preparedData)
  outliers <- names(boxplot@outliers@which)  
  return(outliers)
}

#' Plot Dispersion Estimates - nicer ggplot version of DESeq graph
#'
#' @param cds CountDataSet, required
#' @return plot
#' @seealso \code{\link{DESeq}} for description of the Dispersion plots
#' @export
#' @examples
#' ggplotDispEsts(cds)


ggplotDispEsts = function(cds) {
  estimates = data.frame(means = rowMeans(counts(cds, normalized=TRUE)),
                         variance = fitInfo(cds)$perGeneDispEsts)
  xg = 10^seq(-0.5, 5, length.out=300)
  yg = fitInfo(cds)$dispFun(xg)
  fitline = data.frame(xg=xg, yg=yg)
  p = ggplot(estimates, aes(means, variance)) + geom_point(size=1, alpha=0.4) +
    scale_x_log10() + scale_y_log10() +
    geom_line(data=fitline, aes(xg, yg), color="red") +
    labs(title="Dispersion estimation while pooling all samples") +
    xlab("mean number of mapped reads per gene") +
    ylab("estimated dispersion")
  p
}

#' Cel file IDs of intensity RLE outlier arrays (in characters).
#'
#' @param eset AffyBatch
#' @param logtransform Boolean, log transform data before processing?
#' @return character vector of arrays (CEL file IDs) that are outliers for intensity boxplots.
#' @seealso \code{\link{arrayQualityMetrics}} which this function subsets
#' @export
#' @examples
#' rleoutliers(eset=AffyRaw, logtranform=TRUE)

rleoutliers <- function(eset=NULL, logtransform=TRUE){
  if(class(eset)!="AffyBatch"){
    stop("This function requires microarray data in the AffyBatch format (i.e. from 3'UTR arrays like the Affymetrix U133 or 430A series")
  } else {
    require(arrayQualityMetrics)
    preparedData=prepdata(eset, intgroup=NULL, do.logtransform=logtransform)
    preparedAffy=prepaffy(eset, preparedData)
    rle<-aqm.rle(preparedAffy)
    outliers <- names(nuse@outliers@which)  
  }
  return(outliers)
}

bcv = function(y) {
    # a prettier version of edgeRs BCV plot
#       Check y
        if(!is(y,"DGEList")) stop("y must be a DGEList.")

#       Compute AveLogCPM if not found in y
        A <- aveLogCPM(y$counts,offset=getOffset(y))
        #logCPM <- object$logCPM

#       Points to determine y axis limits
        disp <- sqrt(getDispersion(y))
        if(is.null(disp)) stop("No dispersions to plot")
        if(attr(disp,"type")=="common") disp <- rep(disp,length=length(A))
        df = data.frame(A, disp)

#       Make plot
        p = ggplot(df, aes(A, disp)) + geom_point(alpha=1/10)
        labels <- cols <- NULL
         if(!is.null(y$tagwise.dispersion)) {
           df$tagwise.dispersion = sqrt(y$tagwise.dispersion)
           p = p + geom_point(data=df, aes(A, tagwise.dispersion), alpha=1/10)
         }
        if(!is.null(y$common.dispersion)) {
           df$common.dispersion = sqrt(y$common.dispersion)
           p = p + geom_line(data=df, aes(A, common.dispersion), color="red")
        }
        if(!is.null(y$trended.dispersion)) {
           o <- order(A)
           df$trended.dispersion = y$trended.dispersion
#           x = df[o]
           p = p + geom_line(data=df, aes(A, sqrt(trended.dispersion)), color="blue")
}
        p + xlab("average log CPM") +
            ylab("biological coefficient of variation")
}

fix_excel_symbols = function(symbols) {
    return(unlist(lapply(as.character(symbols), fix_string)))
}

fix_string = function(x) {
    regex_str = "([0-9])-(JAN|FEB|MAR|APR|MAY|JUN|JUL|AUG|SEP|OCT|NOV|DEC|Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec|jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)"
    return(if(any(grep(regex_str, x))) date_fixer(x) else x)
}

date_fixer = function(x) {
    tokens = str_split(x, "-")
    return(paste(toupper(tokens[[1]][2]), tokens[[1]][1], sep=""))
}

base_name = function(txt, ext="") {
    #return base name of a filename, if an optional ext is given,
    #strip it off first
    require(stringr)
    if (ext == "") {
        return(basename(txt))
    }
    else {
        return(basename(str_split(txt, ext)[[1]][[1]]))
    }
}

#' Plots the pvalue quantiles against the uniform distribution. If adjusted pvalues are present, colors those that pass cutoff red 
#' @param pvaldf dataframe, required
#' @param pval_colid character string, column header of column containing unadjusted pvalues, required
#' @param adj_pval_colid character string, column header of column containing adjusted pvalues, required
#' @param adj_pval_cutoff, optional, defaults to 0.05
#' @param title, optional, defaults to "Quantile-quantile plot of p-values against Uniform distribution"
#' @export
#' @examples
#' qqplot_JH(df, pval_colid="pval", adj_pval_colid="padj", adj_pval_cutoff=0.05, title="My qqplot")

qqplot_JH = function(pvaldf,  pval_colid="pval", adj_pval_colid="padj", adj_pval_cutoff=0.05, title="Quantile-quantile plot of p-values against Uniform distribution") {
  require(ggplot2)
  title=title
  pvaldf <- pvaldf[order(pvaldf[,pval_colid], decreasing=F),]
  pvals <- as.vector(unlist(pvaldf[, pval_colid]))
  o <- -log10(pvals)
  e <- -log10( 1:length(o)/length(o) )
  
  if(adj_pval_colid %in% colnames(pvaldf)){
    padjs <- as.numeric(as.vector(unlist(pvaldf$padj)))
    colors <- as.vector(ifelse(padjs<adj_pval_cutoff, "sig", "nonsig"))
  } else {
    colors <- rep( "NA",length(pvals))
  }
  
  plot=qplot(e,o, color=colors, xlim=c(0,max(e[!is.na(e)])), ylim=c(0,max(o[!is.na(o)]))) + stat_abline(intercept=0,slope=1, col="darkgrey")
  plot=plot+labs(title=title)
  plot=plot+scale_x_continuous(name=expression(Expected~~-log[10](italic(p))))
  plot=plot+scale_y_continuous(name=expression(Observed~~-log[10](italic(p))))
  
  if(adj_pval_colid %in% colnames(pvaldf)){
    plot=plot + scale_colour_manual(name="BFH adjusted pvalue", values=c("black", "red"), labels=c(paste("q>", adj_pval_cutoff, sep=""),paste("q<", adj_pval_cutoff,sep="")))
    plot
  } else {
    plot=plot + scale_colour_manual(values=c("black"))
    plot=plot + theme(legend.position="none")
    plot
  }
}

#' Get mouse TF-target pairs from opossum database
#' @import RSQLite
#' @param listgene vector with ensembl ID genes 
#' @param upstream limit distance of the TF to the TSS
#' (upstream to the TSS). 
#' @param downstream limit distance of the TF to the TSS
#' (downstream to the TSS). 
#' @param filesqlite sqlite file containgin the DB.
#' @return data.frame with TF-target pairs
#' @export
getTFpairs<-function(listgenes,
                     filesqlite,
                     upstream=10000,
                     downstream=0)
{
  if ( length(grep("ENSMUSG",listgenes))==0){
    print("your ids are not ensembl ids.")
  }else{
    require(RSQLite)
    sqlite    <- dbDriver("SQLite")
    db <- dbConnect(sqlite,filesqlite)
    gettf<-lapply(listgenes,function(x){
      
      xi<-as.numeric(gsub("^0{1,}","",sub("ENSMUSG","",x)))
      #print(x)
      tf <- dbGetQuery(db, 
                       paste0("select tf,score,con from mousetfpairs where dist > ",
                              -1 * downstream," and dist < ",upstream,
                              " and gene = ",xi,";"))
      if (nrow(tf)>0){
        #data.frame(gene=x,tf=intersect(tf[,1],row.names(mrlog)))
        data.frame(gene=x,tf=tf[,1],score=tf[,2],con=tf[,3])
      }else{
        return(NULL)
      }
    })
    tfpairs<-do.call(rbind,gettf)
    tfpairs[!duplicated(tfpairs),]
  }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PCAplot.eset.R
\name{PCAplot.eset}
\alias{PCAplot.eset}
\title{Pairwise Principal Component Analysis Plots}
\usage{
PCAplot.eset(eset = NULL, categories = NULL, secondary_categories = NULL,
  title = NULL, colorpalette = NULL, alpha = 1, numcomponents = 4)
}
\arguments{
\item{eset}{ExpressionSet, required}

\item{categories}{character vector column identifier containing different categories to highlight with colors, required}

\item{secondary_categories}{character vector column identifier containing different categories to highlight by shape, optional}

\item{title}{title for the plot, required}

\item{colorpalette}{vector of RGB colors (long enough for a color per category), required}

\item{alpha}{alpha shading from 0 (transparent) to 1 (opaque), defaults to 1}

\item{numcomponents}{number of principal components to plot, defaults to 4}
}
\value{
pairwise plots of samples plotted by principal component
}
\description{
Pairwise Principal Component Analysis Plots
}
\examples{
PCAplot.eset(eset=AffyNorm, categories="groups", title="PCAplot - groups", colorpalette=c("#FF0000", "#00FF00", "#0000FF", alpha=0.8, numcomponents=4)
}
\seealso{
\code{\link{pair}} which this function uses to plot all pairwise combos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/boxplotoutliers.R
\name{boxplotoutliers}
\alias{boxplotoutliers}
\title{Cel file IDs of intensity boxplot outlier arrays (in characters).}
\usage{
boxplotoutliers(eset = NULL, logtransform = TRUE)
}
\arguments{
\item{eset}{GeneFeatureSetm, AffyBatch or ExpressionSet object}

\item{logtransform}{Boolean, log transform data before processing?}
}
\value{
character vector of arrays (CEL file IDs) that are outliers for intensity boxplots.
}
\description{
Cel file IDs of intensity boxplot outlier arrays (in characters).
}
\examples{
boxplotoutliers(eset=AffyRaw, logtransform=TRUE)s
}
\seealso{
\code{\link{arrayQualityMetrics}} which this function subsets
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HTMLreport.R
\name{create_report}
\alias{create_report}
\title{Create report of QC}
\usage{
create_report(path, samples, out, title, condition)
}
\arguments{
\item{path}{absolute path to bcbio results (in yaml file after -upload)}

\item{samples}{vector indicating the name as samples are in the previous folder}

\item{out}{path  where you want to create the index.html}

\item{title}{this value would be the title of the document}

\item{condition}{a vector indicating the groups of the samples}
}
\description{
Create report of QC
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qqplot_JH.R
\name{qqplot_JH}
\alias{qqplot_JH}
\title{Plots the pvalue quantiles against the uniform distribution. If adjusted pvalues are present, colors those that pass cutoff red}
\usage{
qqplot_JH(pvaldf, pval_colid = "pval", adj_pval_colid = "padj",
  adj_pval_cutoff = 0.05,
  title = "Quantile-quantile plot of p-values against Uniform distribution")
}
\arguments{
\item{pvaldf}{dataframe, required}

\item{pval_colid}{character string, column header of column containing unadjusted pvalues, required}

\item{adj_pval_colid}{character string, column header of column containing adjusted pvalues, required}

\item{adj_pval_cutoff, }{optional, defaults to 0.05}

\item{title, }{optional, defaults to "Quantile-quantile plot of p-values against Uniform distribution"}
}
\description{
Plots the pvalue quantiles against the uniform distribution. If adjusted pvalues are present, colors those that pass cutoff red
}
\examples{
qqplot_JH(df, pval_colid="pval", adj_pval_colid="padj", adj_pval_cutoff=0.05, title="My qqplot")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mds.R
\name{variance_by_component}
\alias{variance_by_component}
\title{Plot PC importance}
\usage{
variance_by_component(counts, k = 6, d = "euclidian")
}
\arguments{
\item{counts}{matrix}

\item{k}{number of dimension}

\item{d}{distance method (euclidian, cor)}
}
\description{
Plot PC importance
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/row2colnames.r
\name{row2colnames}
\alias{row2colnames}
\title{add a column to a dataframe consisting of the current rownames}
\usage{
row2colnames(df, colname)
}
\arguments{
\item{df}{dataframe}

\item{colname}{character vector specifying new column id}
}
\value{
dataframe with rownames as a column
}
\description{
add a column to a dataframe consisting of the current rownames
}
\examples{
rownamess2col(dataframe, "newcolumnid")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDE.R
\name{plotDE}
\alias{plotDE}
\title{Plots the differntially expressed genes on an MA plot, ggplot style
If adjusted pvalues are present, colors those that pass cutoff red}
\usage{
plotDE(pvaldf, basemean_colid = NULL, log2foldchange_colid = NULL,
  adj_pval_colid = NULL, adj_pval_cutoff = 0.05, plottitle = "MA plot")
}
\arguments{
\item{pvaldf}{dataframe, required}

\item{basemean_colid}{character string, column header of column containing baseMean values, required}

\item{log2foldchange_colid}{character string, column header of column containing log2 transformed fold change values, required}

\item{adj_pval_colid}{character string,column header of column containing adjusted pvalues, required}

\item{adj_pval_cutoff, }{optional, defaults to 0.05}

\item{plottitle}{character string, title for the plot, optional, defaults to "MA plot"}
}
\description{
Plots the differntially expressed genes on an MA plot, ggplot style
If adjusted pvalues are present, colors those that pass cutoff red
}
\examples{
plotDE(df, basemean_colid="baseMean",log2foldchange_colid=log2FoldChange, adj_pval_colid="padj", adj_pval_cutoff=0.05, plottitle="My MA plot")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/col2rownames.R
\name{col2rownames}
\alias{col2rownames}
\title{add a column to a dataframe consisting of the current rownames}
\usage{
col2rownames(df, colname, removecol = TRUE)
}
\arguments{
\item{df}{dataframe}

\item{colname}{character vector specifying id of column with new rownames}

\item{removecol}{boolean specifying wheter to remove the column used to rename rownames}
}
\value{
dataframe with column contents as rownames
}
\description{
add a column to a dataframe consisting of the current rownames
}
\examples{
col2rownames(dataframe, "columnid", FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggheatmap.R
\name{ggheatmap.show}
\alias{ggheatmap.show}
\title{Display a ggheatmap}
\usage{
ggheatmap.show(L, col.width = 0.2, row.width = 0.2)
}
\arguments{
\item{L}{a list with 3 named plots: col, row, centre, generated by ggheatmap}

\item{col.width, row.width}{number between 0 and 1, fraction of the device devoted to the column or row-wise dendrogram. If 0, don't print the dendrogram}
}
\value{
no return value, side effect of displaying plot in current device
}
\description{
this function sets up some viewports, and tries to plot the dendrograms to line up with the heatmap
}
\author{
Chris Wallace
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PCAplot.cds.R
\name{PCAplot.cds}
\alias{PCAplot.cds}
\title{Pairwise Principal Component Analysis Plots of CountDataSet objects}
\usage{
PCAplot.cds(countdataset, categories, categories2, title, colorpalette,
  alpha = 1, numcomponents = 4, normalize.counts = TRUE)
}
\arguments{
\item{countdataset}{CountDataSet, required}

\item{categories}{character string, column header of column containing different categories to highlight with colors, required}

\item{categories2}{character string, column header of column containing different categories to highlight with shapes, optional}

\item{title}{character string, title for the plot, required}

\item{colorpalette}{charcter vector of RGB colors (long enough for a color per category), required}

\item{alpha}{alpha shading from 0 (transparent) to 1 (opaque), defaults to 1}

\item{numcomponents}{number of principal components to plot, defaults to 4}
}
\value{
pairwise plots of samples plotted by principal component
}
\description{
Pairwise Principal Component Analysis Plots of CountDataSet objects
}
\examples{
PCAplot.cds(countdataset=cds, categories="condition", title="PCAplot", colorpalette=c("#FF0000", "#00FF00", "#0000FF"), alpha=0.8, numcomponents=4)
}
\seealso{
\code{\link{pair}} which this function uses to plot all pairwise combos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotate_df.R
\name{annotate_df}
\alias{annotate_df}
\title{Annotate Dataframe containing Ensembl IDs with Gene Symbols and Descriptions}
\usage{
annotate_df(df, df_ensemblid_header, biomart_ensembl_dataset,
  biomart_ensemblid_filter, biomart_genesymbol_attribute)
}
\arguments{
\item{df}{dataframe, required}

\item{df_ensemblid_header, }{character string containing the name of the dataframe column with ensembl ids, required}

\item{biomart_ensembl_dataset, }{character string describing the biomart dataset to use, required}

\item{biomart_ensemblid_filter, }{character string describing the biomart ensembl id filter to use, required}

\item{biomart_genesymbol_attribute, }{character string describing the biomart gene symbol attribute to obtain, required}
}
\value{
annotated dataframe
}
\description{
Annotate Dataframe containing Ensembl IDs with Gene Symbols and Descriptions
}
\examples{
annotate_df(temp, "id", 'mmusculus_gene_ensembl', "ensembl_gene_id", "mgi_symbol")
}
\seealso{
\code{\link{biomaRt}} used to annotate the dataframe
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HTMLreport.R
\name{write_report}
\alias{write_report}
\title{Write report of QC}
\usage{
write_report(report, outfile)
}
\arguments{
\item{report}{an object comming from create_report()}

\item{out}{path where you want to create the index.html (same as used in create_report)}
}
\description{
Write report of QC
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdsplot.RGset.R
\name{mdsplot.RGset}
\alias{mdsplot.RGset}
\title{MDS (MultiDimensional Scaling) Plots}
\usage{
mdsplot.RGset(dat, numPositions = 1000, sampGroups, sampNames,
  main = "MDS plot", alpha = 1, cex = 1)
}
\arguments{
\item{dat}{object, RGChannelSet, required}

\item{numPositions, }{integer, number of most variable positions to use for MDS, defaults to 1000}

\item{sampGroups, }{chracter string, column name in phenoData of RGset containing groups for coloring groups on  plot, required}

\item{sampNames, }{chracter string , column name in phenoData of RGset containing sample labels for plot, optional}

\item{main}{chracter string, title for the plot, defaults to "MDSplot"}

\item{alpha}{floating point, alpha shading from 0 (transparent) to 1 (opaque), defaults to 1}

\item{cex}{integer, size of points in plot, defaults to 1}
}
\value{
plot of samples plotted by MDS
}
\description{
MDS (MultiDimensional Scaling) Plots
}
\examples{
mdsplot.RGset(dat=RGset, numPositions=1000, sampGroups="groups", sampNames="sampleIDs", main="MDSplot", alpha=0.8, cex=10)
}
\seealso{
\code{\link{cmdscale}} which this function uses to calculate MDS
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chb_utils-package.r
\docType{package}
\name{chb_utils}
\alias{chb_utils}
\alias{chb_utils-package}
\title{chb_utils}
\description{
chb_utils
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggplotDispEsts.R
\name{ggplotDispEsts}
\alias{ggplotDispEsts}
\title{Plot Dispersion Estimates - nicer ggplot version of DESeq graph}
\usage{
ggplotDispEsts(cds)
}
\arguments{
\item{cds}{CountDataSet, required}
}
\value{
plot
}
\description{
Plot Dispersion Estimates - nicer ggplot version of DESeq graph
}
\examples{
ggplotDispEsts(cds)
}
\seealso{
\code{\link{DESeq}} for description of the Dispersion plots
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/volcanoPlot.R
\name{volcano_density_plot}
\alias{volcano_density_plot}
\title{Create volcano plot from log2FC and adjusted pvalues data frame}
\usage{
volcano_density_plot(stats, side = "both",
  title = "Volcano Plot with Marginal Distributions", pval.cutoff = 0.05,
  lfc.cutoff = 1, shade.colour = "green", shade.alpha = 0.25,
  point.colour = "gray", point.alpha = 0.75,
  point.outline.colour = "darkgray", line.colour = "gray")
}
\arguments{
\item{stats}{data.frame with two columns: logFC and Adjusted.Pvalue}

\item{side}{plot UP, DOWN or BOTH de-regulated points}

\item{title}{title for the figure}

\item{pval.cutoff}{cutoff for the adjusted pvalue. Default 0.05}

\item{lfc.cutoff}{cutoff for the log2FC. Default 1}

\item{shade.alpha}{transparency value. Default 0.25}

\item{point.colour}{colours for points. Default gray}

\item{point.alpha}{transparency for points. Default 0.75}

\item{point.outline.colour}{Default darkgray}

\item{line.colour}{Defaul gray}
}
\description{
Create volcano plot from log2FC and adjusted pvalues data frame
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggheatmap.R
\name{ggheatmap}
\alias{ggheatmap}
\title{generate a heatmap + dendrograms, ggplot2 style}
\usage{
ggheatmap(x, hm.colours = c("#ffffcc", "#ffeda0", "#fed976", "#feb24c",
  "#fd8d3c", "#fc4e2a", "#e31a1c", "#bd0026", "#800026"))
}
\arguments{
\item{x}{data matrix}

\item{hm.colours}{vector of colours (optional)}
}
\value{
invisibly returns a list of ggplot2 objects. Display them with ggheatmap.show()
}
\description{
generate a heatmap + dendrograms, ggplot2 style
}
\examples{
## test run
## simulate data
library(mvtnorm)
sigma=matrix(0,10,10)
sigma[1:4,1:4] <- 0.6
sigma[6:10,6:10] <- 0.8
diag(sigma) <- 1
X <- rmvnorm(n=100,mean=rep(0,10),sigma=sigma)
 
## make plot
p <- ggheatmap(X)
 
## display plot
ggheatmap.show(p)
}
\author{
Chris Wallace
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotate_df.R
\name{convertIDs}
\alias{convertIDs}
\title{Get other Ids for genes in the same order}
\usage{
convertIDs(ids, from, to, db, ifMultiple = c("putNA", "useFirst"))
}
\arguments{
\item{ids, }{character vector of gene ids}

\item{from, }{type of ID of ids vector}

\item{to, }{type of ID to convert}

\item{db, }{org.species.eg.db class}

\item{ifMultiple, }{what to do when multiple possibles IDs}
}
\value{
annotated dataframe
}
\description{
Get other Ids for genes in the same order
}
\examples{
convertIDs(list_genes, "ENSEMBLTRANS", "SYMBOL", org.Mm.eg.db, "useFirst")
}
\seealso{
\code{\link{AnnotationDbi::select}} used to annotate the dataframe
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runGO.R
\name{print_enrichGO}
\alias{print_enrichGO}
\title{Clean and print results from enrichGO}
\usage{
print_enrichGO(ego, limit = 100)
}
\arguments{
\item{ego}{result object from enrichGO}

\item{limit}{integer limiting the number
of genes in each category. Bigger names
will give broad categories.}
}
\description{
Clean and print results from enrichGO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tfpairs.R
\name{getTFpairs}
\alias{getTFpairs}
\title{Get mouse TF-target pairs from opossum database}
\usage{
getTFpairs(listgenes, filesqlite, upstream = 10000, downstream = 0)
}
\arguments{
\item{filesqlite}{sqlite file containgin the DB.}

\item{upstream}{limit distance of the TF to the TSS
(upstream to the TSS).}

\item{downstream}{limit distance of the TF to the TSS
(downstream to the TSS).}

\item{listgene}{vector with ensembl ID genes}
}
\value{
data.frame with TF-target pairs
}
\description{
Get mouse TF-target pairs from opossum database
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runGO.R
\name{runGO}
\alias{runGO}
\title{Run GO using clusterprofiler}
\usage{
runGO(genes, org, from = "SYMBOL", ont = "BP", universe = NULL)
}
\arguments{
\item{genes}{character vector with list of genes}

\item{org}{OrgDb object (org.Mm.eg.db)}

\item{from}{character indicanting the name gene type.
Options at: (keytypes(org.Mm.eg.db))}

\item{ont}{ontology to do, BP, MF, CC}

\item{universe}{character vector with list of genes to use as universe}
}
\description{
Run GO using clusterprofiler
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_dendro.R
\name{plot_dendro}
\alias{plot_dendro}
\title{ggplot based dendrogram plot}
\usage{
plot_dendro(x, title = "", labels.colname = NULL, colors.colname = NULL)
}
\arguments{
\item{x}{ExpressionSet, required}

\item{title, }{character vector with title of the plot, optional}

\item{labels.colname}{character vector of length one with column id of categorical labels, required}

\item{colors.colname}{character vector of length one with column id of categorical colors, required}
}
\value{
dendrogram plot with categorical labels and colors
}
\description{
ggplot based dendrogram plot
}
\examples{
plot_dendro <- function(eset, title="mydendrogram", labels.colname="age", colors.colname="genotype")
}
\seealso{
\code{\link{ggdendro}} which this function modifies
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotate_df.R
\name{get_biomart}
\alias{get_biomart}
\title{Get biomart annotation from id}
\usage{
get_biomart(v, type = "description", id = "ensembl_gene_id",
  dataset = "hsapiens_gene_ensembl")
}
\arguments{
\item{v}{vector of ids}

\item{type}{character name to get from biomart}

\item{id}{character defining what kind of id is provided}

\item{dataset}{specie database to connect to biomart}
}
\value{
annotated vector in the same order
}
\description{
Get biomart annotation from id
}
\examples{
get_biomrt(v, "gene_biotype")
}
\seealso{
\code{\link{biomaRt}} used to annotate the dataframe
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mds.R
\name{mds}
\alias{mds}
\title{Plot MDS}
\usage{
mds(counts, condition = NULL, k = 6, d = "euclidian", xi = 1, yi = 2)
}
\arguments{
\item{counts}{matrix}

\item{condition}{vector indicating the group of each sample}

\item{k}{number of dimension}

\item{d}{distance method (euclidian, cor)}

\item{xi}{PC for x-axis (1 to k)}

\item{yi}{PC for y-axis (1 to k)}
}
\description{
Plot MDS
}
